program ex1_quick_sort
!
!
! Purpose
! =======
!
!   This program is intended to demonstrate the use of subroutine QUICK_SORT
!   in module Sort_Procedures.
!                                                                              
! LATEST REVISION : 27/06/2006
!                                                                              
! ================================================================================================
!
!
! USED MODULES 
! ============
!
    use Statpack, only : i4b, stnd, false, arth, quick_sort
!   
!
! STRONG TYPING IMPOSED
! =====================
!    
    implicit none
!   
!   
! PARAMETERS 
! ==========
!
! prtunit IS THE PRINTING UNIT
!
    integer(i4b), parameter :: prtunit=6, n=100
!   
!
! SPECIFICATIONS FOR VARIABLES
! ============================
!
    real(stnd), dimension(n) :: x
!
    integer(i4b)               :: i, i1, i2, j, k
    integer(i4b), dimension(n) :: y
!   
!   
! PARAMETERS 
! ==========
!
    character(len=*), parameter :: name_proc='Example 1 of quick_sort'
!   
!
! EXECUTABLE STATEMENTS
! =====================
!
!
!   PRINT LABEL OF THE TEST.
!
    write (prtunit,*)
    write (prtunit,*) name_proc,' :'
    write (prtunit,*) repeat('*', len(name_proc) )
    write (prtunit,*)
!
!   GENERATE RANDOM REAL DATA TO SORT.
!
    call random_number( x )
!
!   GENERATE A RANDOM ORDERING OF THE INTEGERS 1 TO n.
!
    y = arth( 1_i4b, 1_i4b, n ) 
!    
!   STARTING AT THE END, SWAP THE CURRENT LAST INDICATOR WITH ONE
!   RANDOMLY CHOSEN FROM THOSE PRECEEDING IT.

    do i = n, 2, -1
        j = 1 + i * x(i)
        if (j < i) then
            k    = y(i)
            y(i) = y(j)
            y(j) = k
        end if
    end do
!
!   EXAMPLE 1 : SORT THE REAL DATA IN ASCENDING ORDER.
!
    call quick_sort( x  )
!
!   CHECK THAT THE SORTED ARRAY IS NON-DECREASING.
!
    i1 = count( x(1:n-1) > x(2:n) )
!
!   EXAMPLE 2 : SORT THE INTEGER DATA IN DECREASING ORDER.
!
    call quick_sort( y, ascending=false )
!
!   CHECK THAT THE SORTED ARRAY IS NON-INCREASING.
!
    i2 = count( y(1:n-1) < y(2:n) )
!
!   PRINT THE RESULT OF THE TESTS.
!
    if ( i1==0 .and. i2==0 ) then
        write (prtunit,*) 'Example 1 of QUICK_SORT is correct'
    else
        write (prtunit,*) 'Example 1 of QUICK_SORT is incorrect'
    end if
!
!
! END OF PROGRAM ex1_quick_sort
! =============================
!
end program ex1_quick_sort
