program ex1_time_to_string
!
!
! Purpose
! =======
!
!   This program is intended to demonstrate the use of functions CPUSECS and TIME_TO_STRING
!   in module Time_Procedures .
!                                                                              
! LATEST REVISION : 06/07/2006
!                                                                              
! ================================================================================================
!
!
! USED MODULES 
! ============
!
    use Statpack, only : i4b, extd, cpusecs, time_to_string
!   
!
! STRONG TYPING IMPOSED
! =====================
!    
    implicit none
!   
!   
! PARAMETERS 
! ==========
!
! prtunit IS THE PRINTING UNIT.
!
    integer(i4b), parameter :: prtunit=6
!   
!
! SPECIFICATIONS FOR VARIABLES
! ============================
!
    real(extd)   :: tim1, tim2
!
    integer(i4b)  :: i, j
!
    character(len=13) :: string
!   
!   
! PARAMETERS 
! ==========
!
    character(len=*), parameter :: name_proc='Example 1 of time_to_string'
!   
!
! EXECUTABLE STATEMENTS
! =====================
!
!   PRINT LABEL OF THE EXAMPLE.
!
    write (prtunit,*)
    write (prtunit,*) name_proc,' :'
    write (prtunit,*) repeat('*', len(name_proc) )
    write (prtunit,*)
!
!   FUNCTION cpusecs OBTAINS, FROM THE INTRINSIC ROUTINE SYSTEM_CLOCK,
!   THE CURRENT VALUE OF THE SYSTEM CPU USAGE CLOCK. THIS VALUE
!   IS THEN CONVERTED TO SECONDS AND RETURNED AS AN EXTENDED PRECISION
!   REAL VALUE.
!
!   THIS FUNCTIONS ASSUMES THAT THE NUMBER OF CPU CYCLES (CLOCK COUNTS) BETWEEN
!   TWO CALLS IS LESS THAN COUNT_MAX, THE MAXIMUM POSSIBLE VALUE OF CLOCK COUNTS
!   AS RETURNED BY THE INTRINSIC ROUTINE SYSTEM_CLOCK.
!
!   THIS ROUTINE WILL NOT WORK PROPERLY WITH OPENMP .
!
!   A TYPICAL USE OF THIS FUNCTION IS AS FOLLOWS :
!
    tim1 = cpusecs()
    j = 0
    do i=1, 1000000000
        j = j + 1
    end do
    tim2 = cpusecs()
!
!   CONVERT THE CPU TIME tim2-tim1 TO A STRING FORMAT FOR PRINTING AS
!
!           'milliseconds.seconds.minutes.hours'
!
!   WITH SUBROUTINE time_to_string .
!
    string = time_to_string( tim2-tim1 )
!
!   PRINT THE RESULT.
!
    write (prtunit, *)  " CPU Time(s): " // string //  " => milliseconds.seconds.minutes.hours "
!
!
! END OF PROGRAM ex1_time_to_string
! =================================
!
end program ex1_time_to_string
