program ex1_ymd_to_dayweek
!
!
! Purpose
! =======
!
!   This program is intended to demonstrate the use of function YMD_TO_DAYWEEK
!   in module Time_Procedures .
!                                                                              
! LATEST REVISION : 06/07/2006
!                                                                              
! ================================================================================================
!
!
! USED MODULES 
! ============
!
    use Statpack, only : i4b, ymd_to_dayweek, days, get_date
!   
!
! STRONG TYPING IMPOSED
! =====================
!    
    implicit none
!   
!   
! PARAMETERS 
! ==========
!
! prtunit IS THE PRINTING UNIT.
!
    integer(i4b), parameter :: prtunit=6
!   
!
! SPECIFICATIONS FOR VARIABLES
! ============================
!
    integer(i4b) :: iyr, imon, iday, idayweek
!
    character(len=11) :: date
!   
!   
! PARAMETERS 
! ==========
!
    character(len=*), parameter :: name_proc='Example 1 of ymd_to_dayweek'
!   
!
! EXECUTABLE STATEMENTS
! =====================
!
!   PRINT LABEL OF THE EXAMPLE.
!
    write (prtunit,*)
    write (prtunit,*) name_proc,' :'
    write (prtunit,*) repeat('*', len(name_proc) )
    write (prtunit,*)
!
!   GENERATE A DATE.
!
    iyr  = 1902
    imon = 11
    iday = 15
!
!   DETERMINE THE DAY OF THE WEEK FROM FROM GREGORIAN YEAR (iyr),
!   MONTH (imon) AND DAY (iday).
!
    idayweek = ymd_to_dayweek( iyr, imon, iday )
!
!   FUNCTION ymd_to_dayweek RETURNS THE DAY OF THE WEEK (E.G., MON, TUE,...) AS AN INTEGER 
!   INDEX (MON=1 TO SUN=7) FOR THE GIVEN YEAR, MONTH, AND DAY IN THE GREGORIAN
!   CALENDAR PROMULGATED BY GREGORY XIII ON FRIDAY, 15 OCTOBER 1582.
!
!   NOTE THAT THE GREGORIAN CALENDAR WAS ADOPTED IN OCT. 15, 1582, AND HENCE
!   THIS ALGORITHM WILL NOT WORK PROPERLY FOR DATES EARLY THAN 10-15-1582.
!
!   PRINT THE RESULT.
!
    call get_date( iyr, imon, iday, date )
!
    write (prtunit,*) 'The date ' // date // ' is a ' // days(idayweek)
!
!
!
! END OF PROGRAM ex1_ymd_to_dayweek
! ================================
!
end program ex1_ymd_to_dayweek
