module Statpack
! ####################################################################################
!
! Copyright 2018 IRD
!
! This file is part of statpack.
!
! statpack is free software: you can redistribute it and/or modify
! it under the terms of the GNU Lesser General Public License as
! published by the Free Software Foundation, either version 3 of 
! the License, or (at your option) any later version.
!
! statpack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You can find a copy of the GNU Lesser General Public License
! in the statpack/doc directory.
!
! ####################################################################################
!                                                                                    *
! ************************************************************************************
! INTERFACE MODULE EXPORTING ALL PUBLIC CONSTANTS, VARIABLES, SUBROUTINES AND        *
! FUNCTIONS FROM OTHER MODULES AVAILABLE IN STATPACK.                                * 
!                                                                                    * 
! LATEST REVISION : 09/08/2018                                                       *
!                                                                                    *
! ####################################################################################
!                                                                                    *
! ************************************************************************************
!
!
! USED MODULES
! ============
!   
    use Select_Parameters, only : i1b, i2b, i4b, i8b, lgl, stnd, extd,    &
                                  n1_def, n2_def, n3_def,                 &
                                  defunit, urandom_file,                  &
                                  omp_limit, omp_limit2, omp_chunk,       &
                                  npar_arth, npar2_arth,                  &
                                  npar_geop, npar2_geop,                  &
                                  npar_cumsum, npar_cumprod,              &
                                  npar_poly, npar_polyterm
!
    use Derived_Types, only     : sprs2_stnd, sprs2_stndc, sprs2_extd,    &
                                  sprs2_extdc
!   
    use Logical_Constants
    use Reals_Constants
    use Num_Constants
    use Char_Constants
    use Utilities
    use Utilities_With_Pnter
    use Random
!   
    use String_Procedures
    use Print_Procedures
    use Time_Procedures
    use Sort_Procedures
!   
    use FFT_Procedures
    use Giv_Procedures
    use Hous_Procedures
    use Lin_Procedures
    use Eig_Procedures
    use QR_Procedures
    use SVD_Procedures
    use LLSQ_Procedures
    use Prob_Procedures
    use Stat_Procedures
    use Mul_Stat_Procedures
    use Time_Series_Procedures
!
    use BLAS_interfaces
    use Lapack_interfaces
!
! PUBLIC ENTITIES 
! ===============
!
    public
!
!
! ************************
! END OF MODULE Statpack *
! ************************
!
end module Statpack
